<script setup>
    import { useForm } from '@inertiajs/vue3';
    import AppLayout from '@/Layouts/AppLayout.vue';
    import Pagination from '@/Components/Pagination.vue';
    import Search from '@/Components/Search.vue';
    import Select from '@/Components/Select.vue';
    import InputLabel from '@/Components/InputLabel.vue';
    import ConfirmationModal from '@/Components/Modals/Confirmation.vue';
</script>

<template>
    <AppLayout :title="'Users'">
        <h1 v-if="currentUser.role === 'lawyer'" class="text-2xl font-bold text-center">Clients</h1>
        <h1 v-else class="text-2xl font-bold text-center">Users</h1>

        <div class="flow-root mt-5">
            <div v-if="selectedUsersIds.length > 0" class="flex float-left">
                <div class="flex items-center">
                    <Select
                        id="bulk-actions"
                        v-model="bulkAction"
                        :items="bulk_actions"
                        class="mr-3 w-36"
                        @change="onSelectAction($event)"
                    />
                    <InputLabel for="bulk-actions" value="Actions" />
                </div>
            </div>
            <div class="flex float-right">
                <Search
                    :search="filters.search"
                    @resetSearch="resetSearch"
                    @performSearch="searchUsers"
                />
                <div v-if="currentUser.role === 'admin'" class="flex">
                    <div class="mx-2 flex items-center">
                        <InputLabel for="role" value="Role" />
                        <Select
                            id="role"
                            v-model="filters.role"
                            :items="roles"
                            class="ml-3 w-36"
                            @change="onChangeRole($event)"
                        />
                    </div>
                    <div class="mx-2 flex items-center">
                        <InputLabel for="status" value="Status" />
                        <Select
                            id="status"
                            v-model="filters.status"
                            :items="statuses"
                            class="ml-3 w-36"
                            @change="onChangeStatus($event)"
                        />
                    </div>
                </div>
            </div>
        </div>

        <div class="mt-5 mb-10 mx-auto bg-white relative shadow-md">
            <table class="w-full text-sm text-left text-gray-500 dark:text-gray-400">
                <thead class="text-md text-gray-700 bg-cyan-400 dark:bg-gray-700 dark:text-gray-400">
                    <tr class="grid grid-cols-12 gap-2">
                        <th v-if="currentUser.role === 'lawyer'" scope="col" class="col-span-3 py-3 text-center text-lg">
                            Name
                        </th>
                        <th v-if="currentUser.role === 'admin'" scope="col" class="col-span-3 grid grid-cols-3 gap-2">
                            <th scope="col" class="py-3 text-center text-lg">
                                <input
                                    type="checkbox"
                                    class="checkbox"
                                    v-model="allSelected"
                                    @change="checkSelectAll()"
                                />
                            </th>
                            <th scope="col" class="col-span-2 py-3 text-center text-lg">
                                Name
                            </th>
                        </th>
                        <th scope="col" class="col-span-3 py-3 text-center text-lg">
                            Email
                        </th>
                        <th v-if="currentUser.role === 'lawyer'" scope="col" class="col-span-4 py-3 text-center text-lg">
                            Business
                        </th>
                        <th v-if="currentUser.role === 'admin'" scope="col" class="col-span-4 grid grid-cols-4 gap-2">
                            <th scope="col" class="col-span-3 py-3 text-center text-lg">
                                Business
                            </th>
                            <th scope="col" class="py-3 text-center text-lg">
                                Role
                            </th>
                        </th>
                        <th scope="col" class="col-span-2">
                            &nbsp;
                        </th>
                    </tr>
                </thead>
                <tbody>
                    <tr
                        class="bg-white border-y-2 dark:bg-gray-800 dark:border-gray-700 grid grid-cols-12 gap-2 odd:bg-white even:bg-gray-200"
                        v-for="user in users.data"
                        :key="user.id"
                    >
                        <td v-if="currentUser.role === 'lawyer'" class="col-span-3 px-3 py-3 font-medium text-gray-700 dark:text-white whitespace-nowrap">
                            {{ user.name }}
                        </td>
                        <td v-if="currentUser.role === 'admin'" class="col-span-3 grid grid-cols-3 gap-2">
                            <td class="px-3 py-3 font-medium text-gray-700 dark:text-white whitespace-nowrap text-center">
                                <input
                                    type="checkbox"
                                    class="checkbox"
                                    v-model="user.selected"
                                    @change="selectItem()"
                                />
                            </td>
                            <td class="col-span-2 px-3 py-3 font-medium text-gray-700 dark:text-white whitespace-nowrap">
                                {{ user.name }}
                            </td>
                        </td>
                        <td class="col-span-3 px-3 py-3 font-medium text-gray-700 dark:text-white whitespace-nowrap">
                            {{ user.email }}
                        </td>
                        <td v-if="currentUser.role === 'lawyer'" class="col-span-4 px-3 py-3 font-medium text-gray-700 dark:text-white whitespace-nowrap">
                            {{ user.business }}
                        </td>
                        <td v-if="currentUser.role === 'admin'" class="col-span-4 grid grid-cols-4 gap-2">
                            <td class="col-span-3 px-3 py-3 font-medium text-gray-700 dark:text-white whitespace-nowrap">
                                {{ user.business }}
                            </td>
                            <td class="px-3 py-3 font-medium text-gray-700 dark:text-white whitespace-nowrap text-center">
                                {{ user.role.name }}
                            </td>
                        </td>
                        <td class="col-span-2 px-3 py-3 font-semibold text-gray-600 dark:text-white whitespace-nowrap text-center">
                            <span class="text-lg space-x-2">
                                <Link
                                    :href="route('users.show', [
                                        {'id': user.id},
                                    ])"
                                    class="hover:text-black"
                                    :title="currentUser.role === 'admin' ? 'View and Edit User' : 'View User'"
                                >
                                    <font-awesome-icon icon="fa-regular fa-eye" />
                                </Link>
                                <span v-if="currentUser.role === 'admin'" class="space-x-2">
                                    <button
                                        v-if="!filters.status"
                                        @click="confirmDeactivateUser(user.id, user.name)"
                                        class="hover:text-black"
                                        title="Deactivate User"
                                    >
                                        <font-awesome-icon icon="fa-solid fa-ban" />
                                    </button>
                                    <button
                                        v-if="filters.status === 'inactive'"
                                        @click="confirmActivateUser(user.id, user.name)"
                                        class="hover:text-black"
                                        title="Activate User"
                                    >
                                        <font-awesome-icon icon="fa-solid fa-circle-play" />
                                    </button>
                                    <span v-if="filters.status === 'deleted'" class="space-x-2">
                                        <button
                                            @click="confirmRestoreUser(user.id, user.name)"
                                            class="hover:text-black"
                                            title="Restore User"
                                        >
                                            <font-awesome-icon icon="fa-solid fa-trash-arrow-up" />
                                        </button>
                                        <button
                                            @click="confirmUltimatelyDeleteUser(user.id, user.name)"
                                            class="hover:text-black"
                                            title="Ultimately Delete User"
                                        >
                                            <font-awesome-icon icon="fa-solid fa-user-xmark" />
                                        </button>
                                    </span>
                                    <button
                                        v-else
                                        @click="confirmDeleteUser(user.id, user.name)"
                                        class="hover:text-black"
                                        title="Delete User"
                                    >
                                        <font-awesome-icon icon="fa-solid fa-trash-can" />
                                    </button>
                                </span>
                                <span v-if="currentUser.role === 'lawyer'">
                                    <Link
                                        href="#"
                                        class="hover:text-black"
                                        title="Upload Document"
                                    >
                                        <font-awesome-icon icon="fa-solid fa-file-arrow-up" />
                                    </Link>
                                    <Link
                                        href="#"
                                        class="hover:text-black"
                                        title="Add Calendar Event"
                                    >
                                        <font-awesome-icon icon="fa-solid fa-calendar-plus" />
                                    </Link>
                                </span>
                                <Link
                                    v-if="filters.status !== 'deleted'"
                                    href="#"
                                    class="hover:text-black"
                                    title="Write Message"
                                >
                                    <font-awesome-icon icon="fa-solid fa-pen-to-square" />
                                </Link>
                            </span>
                        </td>
                    </tr>
                </tbody>
            </table>
            <Pagination
                v-if="users_number > items_on_page"
                :links="users.links"
                class="ml-4 py-4 text-lg"
                :filters="filters"
            />
        </div>
    </AppLayout>

    <ConfirmationModal
        :showModal="confirmingDeactivateUser"
        title="Deactivate User"
        :content="'Are you sure you want to deactivate the user ' + selectedUserName + '?'"
        buttonConfirmationType="danger"
        buttonConfirmationText="Deactivate"
        @closeModal="confirmingDeactivateUser = false"
        @confirmAction="confirmingDeactivateUser = deactivateUser(selectedUserId)"
    />

    <ConfirmationModal
        :showModal="confirmingActivateUser"
        title="Activate User"
        :content="'Are you sure you want to activate deactivated user ' + selectedUserName + '?'"
        buttonConfirmationType="primary"
        buttonConfirmationText="Activate"
        @closeModal="confirmingActivateUser = false"
        @confirmAction="confirmingActivateUser = activateUser(selectedUserId)"
    />

    <ConfirmationModal
        :showModal="confirmingDeleteUser"
        title="Delete User"
        :content="'Are you sure you want to delete the user ' + selectedUserName + '?'"
        buttonConfirmationType="danger"
        buttonConfirmationText="Delete"
        @closeModal="confirmingDeleteUser = false"
        @confirmAction="confirmingDeleteUser = deleteUser(selectedUserId)"
    />

    <ConfirmationModal
        :showModal="confirmingRestoreUser"
        title="Restore User"
        :content="'Are you sure you want to restore the user ' + selectedUserName + '?'"
        buttonConfirmationType="primary"
        buttonConfirmationText="Restore"
        @closeModal="confirmingRestoreUser = false"
        @confirmAction="confirmingRestoreUser = restoreUser(selectedUserId)"
    />

    <ConfirmationModal
        :showModal="confirmingUltimatelyDeleteUser"
        title="Ultimate Delete User"
        :content="'Are you sure you want to delete the user ' + selectedUserName + ' ultimately?'"
        buttonConfirmationType="danger"
        buttonConfirmationText="Delete"
        @closeModal="confirmingUltimatelyDeleteUser = false"
        @confirmAction="confirmingUltimatelyDeleteUser = ultimatelyDeleteUser(selectedUserId)"
    />

    <ConfirmationModal
        :showModal="confirmingDeleteUsers"
        title="Delete Selected Users"
        :content="'Are you sure you want to delete selected users?'"
        buttonConfirmationType="danger"
        buttonConfirmationText="Delete"
        @closeModal="resetBulkAction()"
        @confirmAction="deleteSelectedUsers()"
    />

    <ConfirmationModal
        :showModal="confirmingDeactivateUsers"
        title="Deactivate Selected Users"
        :content="'Are you sure you want to deactivate selected users?'"
        buttonConfirmationType="danger"
        buttonConfirmationText="Deactivate"
        @closeModal="resetBulkAction()"
        @confirmAction="deactivateSelectedUsers()"
    />

    <ConfirmationModal
        :showModal="confirmingRestoreUsers"
        title="Restore Selected Users"
        :content="'Are you sure you want to restore selected users?'"
        buttonConfirmationType="primary"
        buttonConfirmationText="Restore"
        @closeModal="resetBulkAction()"
        @confirmAction="restoreSelectedUsers()"
    />

    <ConfirmationModal
        :showModal="confirmingActivateUsers"
        title="Activate Selected Users"
        :content="'Are you sure you want to activate selected users?'"
        buttonConfirmationType="primary"
        buttonConfirmationText="Activate"
        @closeModal="resetBulkAction()"
        @confirmAction="activateSelectedUsers()"
    />

    <ConfirmationModal
        :showModal="confirmingUltimatelyDeleteUsers"
        title="Ultimately Delete Selected Users"
        :content="'Are you sure you want to delete selected users ultimately?'"
        buttonConfirmationType="danger"
        buttonConfirmationText="Ultimately Delete"
        @closeModal="resetBulkAction()"
        @confirmAction="ultimatelyDeleteSelectedUsers()"
    />
</template>

<script>
    import { router } from '@inertiajs/vue3';

    export default {
        props: {
            users: {
                type: Object,
                default: {}
            },
            roles: {
                type: Array,
                default: []
            },
            statuses: {
                type: Array,
                default: []
            },
            bulk_actions: {
                type: Array,
                default: []
            },
            users_number: {
                type: Number,
                default: 0
            },
            items_on_page: {
                type: Number,
                default: 0
            }
        },
        data() {
            return {
                currentUser: {},
                filters: {
                    search: '',
                    role: 'client',
                    status: '',
                },
                usersData: [],
                bulkAction: '',
                confirmingDeactivateUser: false,
                confirmingActivateUser: false,
                confirmingDeleteUser: false,
                confirmingRestoreUser: false,
                confirmingUltimatelyDeleteUser: false,
                confirmingDeleteUsers: false,
                confirmingDeactivateUsers: false,
                confirmingRestoreUsers: false,
                confirmingActivateUsers: false,
                confirmingUltimatelyDeleteUsers: false,
                selectedUserId: 0,
                selectedUserName: '',
                selectedUsersIds: [],
                allSelected: false,
            };
        },
        created() {
            this.initCurrentUser();
            this.initFilters();
            this.initUsersData();
        },
        methods: {
            searchUsers(searchString) {
                this.filters.search = searchString;

                this.filtersRequest();
            },
            resetSearch() {
                this.searchUsers('');
            },
            onChangeRole(event) {
                this.filters.role = event.target.value;

                this.filtersRequest();
            },
            onChangeStatus(event) {
                this.filters.status = event.target.value;

                this.filtersRequest();
            },
            initCurrentUser() {
                if (this.$page.props.user) {
                    this.currentUser = this.$page.props.user;
                }
            },
            initFilters() {
                this.filters.search = this.$page.props.filters.search;
                this.filters.role = this.$page.props.filters.role;
                this.filters.status = this.$page.props.filters.status;
            },
            selectAll() {
                this.selectedUsersIds = [];

                for (let index in this.usersData) {
                    this.usersData[index].selected = true;
                    this.selectedUsersIds.push(this.usersData[index].id);
                }
            },
            deselectAll() {
                this.selectedUsersIds = [];

                for (let index in this.usersData) {
                    this.usersData[index].selected = false;
                }
            },
            initUsersData() {
                this.usersData = [];

                for (let index in this.users.data) {
                    this.usersData.push(this.users.data[index]);
                }

                this.deselectAll;
            },
            checkSelectAll() {
                if (this.allSelected) {
                    this.selectAll();

                    return;
                }

                this.deselectAll();
            },
            filtersRequest() {
                router.get(route('users.index'), {filters: this.filters}, {
                    preserverState: true,
                    replace: true,
                });
            },
            confirmDeactivateUser(userId, userName) {
                this.confirmingDeactivateUser = true;
                this.selectedUserId = userId;
                this.selectedUserName = userName;
            },
            confirmActivateUser(userId, userName) {
                this.confirmingActivateUser = true;
                this.selectedUserId = userId;
                this.selectedUserName = userName;
            },
            confirmDeleteUser(userId, userName) {
                this.confirmingDeleteUser = true;
                this.selectedUserId = userId;
                this.selectedUserName = userName;
            },
            confirmRestoreUser(userId, userName) {
                this.confirmingRestoreUser = true;
                this.selectedUserId = userId;
                this.selectedUserName = userName;
            },
            confirmUltimatelyDeleteUser(userId, userName) {
                this.confirmingUltimatelyDeleteUser = true;
                this.selectedUserId = userId;
                this.selectedUserName = userName;
            },
            onSelectAction(event) {
                if (event.target.value === 'deactivate') {
                    this.confirmingDeactivateUsers = true;
                }

                if (event.target.value === 'delete') {
                    this.confirmingDeleteUsers = true;
                }

                if (event.target.value === 'restore') {
                    this.confirmingRestoreUsers = true;
                }

                if (event.target.value === 'activate') {
                    this.confirmingActivateUsers = true;
                }

                if (event.target.value === 'ultimately delete') {
                    this.confirmingUltimatelyDeleteUsers = true;
                }
            },
            resetBulkAction() {
                this.bulkAction = '';
                this.allSelected = false;
                this.confirmingDeleteUsers = false;
                this.confirmingDeactivateUsers = false;
                this.confirmingRestoreUsers = false;
                this.confirmingActivateUsers = false;
                this.confirmingUltimatelyDeleteUsers = false;
            },
            findSelectedUsers() {
                this.selectedUsersIds = [];

                for (let index in this.usersData) {
                    if (this.usersData[index].selected) {
                        this.selectedUsersIds.push(this.usersData[index].id);
                    }
                }
            },
            selectItem() {
                this.findSelectedUsers()

                if (this.allSelected && this.selectedUsersIds.length < this.usersData.length) {
                    this.allSelected = false;
                }

                if (this.selectedUsersIds.length === this.usersData.length && !this.allSelected) {
                    this.allSelected = true;
                }
            },
            actionsAfterConfirmation() {
                this.resetBulkAction();
                this.selectedUsersIds = [];
                this.deselectAll();
            },
            deactivateUser(id) {
                const queryData = {
                    id: id,
                    filters: this.filters,
                };

                router.post(route('user-deactivation'), queryData, {
                    preserveScroll: true,
                    onSuccess: () => {
                        this.initUsersData();
                    }
                });
            },
            activateUser(id) {
                const queryData = {
                    id: id,
                    filters: this.filters,
                };

                router.post(route('user-activation'), queryData, {
                    preserveScroll: true,
                    onSuccess: () => {
                        this.initUsersData();
                    }
                });
            },
            deleteUser (id) {
                const queryData = {
                    id: id,
                    filters: this.filters,
                };

                router.delete(route('user-destroy', queryData), {
                    preserveScroll: true,
                    onSuccess: () => {
                        this.initUsersData();
                    }
                });

                return false;
            },
            restoreUser(id) {
                const queryData = {
                    id: id,
                    filters: this.filters,
                };

                router.post(route('user-restoration'), queryData, {
                    preserveScroll: true,
                    onSuccess: () => {
                        this.initUsersData();
                    }
                });
            },
            ultimatelyDeleteUser (id) {
                const queryData = {
                    id: id,
                    filters: this.filters,
                };

                router.delete(route('user-ultimately-destroy', queryData), {
                    preserveScroll: true,
                    onSuccess: () => {
                        this.initUsersData();
                    }
                });

                return false;
            },
            deleteSelectedUsers() {
                const queryData = {
                    ids: this.selectedUsersIds,
                    filters: this.filters,
                };

                this.actionsAfterConfirmation();

                router.delete(route('users-bulk-deletion', queryData), {
                    preserveScroll: true,
                    onSuccess: () => {
                        this.initUsersData();
                    }
                });
            },
            deactivateSelectedUsers() {
                const queryData = {
                    ids: this.selectedUsersIds,
                    filters: this.filters,
                };

                this.actionsAfterConfirmation();

                router.post(route('users-bulk-deactivation'), queryData, {
                    preserveScroll: true,
                    onSuccess: () => {
                        this.initUsersData();
                    }
                });
            },
            restoreSelectedUsers() {
                const queryData = {
                    ids: this.selectedUsersIds,
                    filters: this.filters,
                };

                this.actionsAfterConfirmation();

                router.post(route('users-bulk-restoration'), queryData, {
                    preserveScroll: true,
                    onSuccess: () => {
                        this.initUsersData();
                    }
                });
            },
            activateSelectedUsers() {
                const queryData = {
                    ids: this.selectedUsersIds,
                    filters: this.filters,
                };

                this.actionsAfterConfirmation();

                router.post(route('users-bulk-activation'), queryData, {
                    preserveScroll: true,
                    onSuccess: () => {
                        this.initUsersData();
                    }
                });
            },
            ultimatelyDeleteSelectedUsers() {
                const queryData = {
                    ids: this.selectedUsersIds,
                    filters: this.filters,
                };

                this.actionsAfterConfirmation();

                router.delete(route('users-bulk-ultimately-deletion', queryData), {
                    preserveScroll: true,
                    onSuccess: () => {
                        this.initUsersData();
                    }
                });
            },
        },
    };
</script>
